package com.neusoft.smart.pos.exchangeStrategy.persistent.domain;

import java.util.ArrayList;
import java.util.List;

public class ExchangeStrategyTypeDictExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public ExchangeStrategyTypeDictExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public ExchangeStrategyTypeDictExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andStrategyTypeIdIsNull() {
            addCriterion("strategy_type_id is null");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdIsNotNull() {
            addCriterion("strategy_type_id is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdEqualTo(Integer value) {
            addCriterion("strategy_type_id =", value, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdNotEqualTo(Integer value) {
            addCriterion("strategy_type_id <>", value, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdGreaterThan(Integer value) {
            addCriterion("strategy_type_id >", value, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("strategy_type_id >=", value, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdLessThan(Integer value) {
            addCriterion("strategy_type_id <", value, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdLessThanOrEqualTo(Integer value) {
            addCriterion("strategy_type_id <=", value, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdIn(List<Integer> values) {
            addCriterion("strategy_type_id in", values, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdNotIn(List<Integer> values) {
            addCriterion("strategy_type_id not in", values, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdBetween(Integer value1, Integer value2) {
            addCriterion("strategy_type_id between", value1, value2, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyTypeIdNotBetween(Integer value1, Integer value2) {
            addCriterion("strategy_type_id not between", value1, value2, "strategyTypeId");
            return (Criteria) this;
        }

        public Criteria andStrategyNameIsNull() {
            addCriterion("strategy_name is null");
            return (Criteria) this;
        }

        public Criteria andStrategyNameIsNotNull() {
            addCriterion("strategy_name is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyNameEqualTo(String value) {
            addCriterion("strategy_name =", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameNotEqualTo(String value) {
            addCriterion("strategy_name <>", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameGreaterThan(String value) {
            addCriterion("strategy_name >", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameGreaterThanOrEqualTo(String value) {
            addCriterion("strategy_name >=", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameLessThan(String value) {
            addCriterion("strategy_name <", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameLessThanOrEqualTo(String value) {
            addCriterion("strategy_name <=", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameLike(String value) {
            addCriterion("strategy_name like", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameNotLike(String value) {
            addCriterion("strategy_name not like", value, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameIn(List<String> values) {
            addCriterion("strategy_name in", values, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameNotIn(List<String> values) {
            addCriterion("strategy_name not in", values, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameBetween(String value1, String value2) {
            addCriterion("strategy_name between", value1, value2, "strategyName");
            return (Criteria) this;
        }

        public Criteria andStrategyNameNotBetween(String value1, String value2) {
            addCriterion("strategy_name not between", value1, value2, "strategyName");
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNull() {
            addCriterion("description is null");
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNotNull() {
            addCriterion("description is not null");
            return (Criteria) this;
        }

        public Criteria andDescriptionEqualTo(String value) {
            addCriterion("description =", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotEqualTo(String value) {
            addCriterion("description <>", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionGreaterThan(String value) {
            addCriterion("description >", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("description >=", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLessThan(String value) {
            addCriterion("description <", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLessThanOrEqualTo(String value) {
            addCriterion("description <=", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLike(String value) {
            addCriterion("description like", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotLike(String value) {
            addCriterion("description not like", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionIn(List<String> values) {
            addCriterion("description in", values, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotIn(List<String> values) {
            addCriterion("description not in", values, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionBetween(String value1, String value2) {
            addCriterion("description between", value1, value2, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotBetween(String value1, String value2) {
            addCriterion("description not between", value1, value2, "description");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameIsNull() {
            addCriterion("strategy_bean_name is null");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameIsNotNull() {
            addCriterion("strategy_bean_name is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameEqualTo(String value) {
            addCriterion("strategy_bean_name =", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameNotEqualTo(String value) {
            addCriterion("strategy_bean_name <>", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameGreaterThan(String value) {
            addCriterion("strategy_bean_name >", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameGreaterThanOrEqualTo(String value) {
            addCriterion("strategy_bean_name >=", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameLessThan(String value) {
            addCriterion("strategy_bean_name <", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameLessThanOrEqualTo(String value) {
            addCriterion("strategy_bean_name <=", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameLike(String value) {
            addCriterion("strategy_bean_name like", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameNotLike(String value) {
            addCriterion("strategy_bean_name not like", value, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameIn(List<String> values) {
            addCriterion("strategy_bean_name in", values, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameNotIn(List<String> values) {
            addCriterion("strategy_bean_name not in", values, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameBetween(String value1, String value2) {
            addCriterion("strategy_bean_name between", value1, value2, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andStrategyBeanNameNotBetween(String value1, String value2) {
            addCriterion("strategy_bean_name not between", value1, value2, "strategyBeanName");
            return (Criteria) this;
        }

        public Criteria andParamListIsNull() {
            addCriterion("param_list is null");
            return (Criteria) this;
        }

        public Criteria andParamListIsNotNull() {
            addCriterion("param_list is not null");
            return (Criteria) this;
        }

        public Criteria andParamListEqualTo(String value) {
            addCriterion("param_list =", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListNotEqualTo(String value) {
            addCriterion("param_list <>", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListGreaterThan(String value) {
            addCriterion("param_list >", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListGreaterThanOrEqualTo(String value) {
            addCriterion("param_list >=", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListLessThan(String value) {
            addCriterion("param_list <", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListLessThanOrEqualTo(String value) {
            addCriterion("param_list <=", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListLike(String value) {
            addCriterion("param_list like", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListNotLike(String value) {
            addCriterion("param_list not like", value, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListIn(List<String> values) {
            addCriterion("param_list in", values, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListNotIn(List<String> values) {
            addCriterion("param_list not in", values, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListBetween(String value1, String value2) {
            addCriterion("param_list between", value1, value2, "paramList");
            return (Criteria) this;
        }

        public Criteria andParamListNotBetween(String value1, String value2) {
            addCriterion("param_list not between", value1, value2, "paramList");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}